﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Collections.ObjectModel;
using Infragistics.Windows.Editors;

namespace DataGridWithCombo
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }

        void Combo_Loaded(object sender, RoutedEventArgs e)
        {
            //(sender as XamComboEditor).SelectedIndex = 0;
        }

        private void dgPDUsers_SelectedItemsChanged(object sender, Infragistics.Windows.DataPresenter.Events.SelectedItemsChangedEventArgs e)
        {

        }

        private void dgPDUsers_Loaded(object sender, RoutedEventArgs e)
        {
            SetActiveRecord(2);
        }

        private void dgPDUsers_Initialized(object sender, EventArgs e)
        {
            PopulatePDUserList(PDUser.SelfListAll());
        }

        private void PopulatePDUserList(ObservableCollection<PDUser> PDUserList)
        {
            this.dgPDUsers.DataContext = null;
            this.dgPDUsers.DataContext = PDUserList;
        }


        private void SetActiveRecord(int SelectedRow)
        {
            if ( this.dgPDUsers.Records.Count > 0 )
            {
                this.dgPDUsers.Records[SelectedRow].IsSelected = true;
                this.dgPDUsers.ActiveRecord = this.dgPDUsers.Records[SelectedRow];
            }
        }

    }

    public class PDUser
    {
        public static ObservableCollection<PDUser> SelfListAll()
        {
            Random r = new Random();
            ObservableCollection<PDUser> pd = new ObservableCollection<PDUser>();


            for ( int i = 0 ; i < 50 ; i++ )
            {
                PDUser user = new PDUser
                {
                    PDUserID = i,
                    Name = "User " + i,
                    ActiveName = "Active" + i,
                    FirstName = "Active" + i,
                    LastName = "Active" + i,
                    Clinics = new List<Clinic>(),
                    Roles = new List<Role>(),
                    LockedOut = i % 2 == 0,
                    MyClinic = new Clinic
                    {
                        ClinicID = 0,
                        Name = "Clinc 0"
                    }
                };

                for ( int j = 0 ; j < r.Next(5, 15) ; j++ )
                {
                    user.Clinics.Add(new Clinic
                    {
                        ClinicID = j,
                        Name = "Clinc " + j
                    });
                    user.Roles.Add(new Role
                    {
                        RoleID = j,
                        Name = "Role " + j
                    });
                }

                pd.Add(user);
            }

            return pd;
        }

        public int PDUserID
        {
            get;
            set;
        }
        public string Name
        {
            get;
            set;
        }
        public string FirstName
        {
            get;
            set;
        }
        public string LastName
        {
            get;
            set;
        }
        public string ActiveName
        {
            get;
            set;
        }
        public List<Clinic> Clinics
        {
            get;
            set;
        }
        public List<Role> Roles
        {
            get;
            set;
        }
        public bool LockedOut
        {
            get;
            set;
        }

        //Combo Columns
        public Clinic MyClinic
        {
            get
            {
                return _clinic;
            }
            set
            {
                _clinic = value;
            }
        }
        private Clinic _clinic = null;
        public int RoleID
        {
            get;
            set;
        }
    }

    public class Clinic
    {
        public int ClinicID
        {
            get
            {
                return _clinicID;
            }
            set
            {
                _clinicID = value;
            }
        }
        private int _clinicID = -1;
        public string Name
        {
            get;
            set;
        }
    }

    public class Role
    {
        public int RoleID
        {
            get;
            set;
        }
        public string Name
        {
            get;
            set;
        }
    }

}
